#!/bin/bash -e
Current_DIR=$(cd `dirname $0`; pwd)

advertiseAddr=""
registry=""
while [ -n $1 ]
do
	case $1 in 
		--advertise-addr) advertiseAddr=$2; shift 2;;
		--registry) registry=$2; shift 2;;
		*) break ;;
	esac
done

source $Current_DIR/.env

if [ "$advertiseAddr"x != x  ]; then
	sed -i 's|IMANAGER_HOST_IP=.*|IMANAGER_HOST_IP='"$advertiseAddr"'|g' .env
	if [ -z $COMPOSE_DOCKER_IP ]; then
		sed -i 's|COMPOSE_DOCKER_IP=.*|COMPOSE_DOCKER_IP='"$advertiseAddr"'|g' .env
	fi
fi
if [ "$registry"x != x  ]; then
	sed -i 's|IMANAGER_REGISTRY_URL=.*|IMANAGER_REGISTRY_URL='"$registry"/'|g' .env
fi
source $Current_DIR/.env
mkdir -p /opt/compose/bin
cp $Current_DIR/docker-compose.sh /opt/compose/bin/docker-compose
chmod +x /opt/compose/bin/docker-compose

if [ -z $(docker images -q supermap/compose:1.11.2) ]; then
	docker pull $IMANAGER_REGISTRY_URL"supermap/compose:1.11.2"
	docker tag $IMANAGER_REGISTRY_URL"supermap/compose:1.11.2" supermap/compose:1.11.2
	docker rmi $IMANAGER_REGISTRY_URL"supermap/compose:1.11.2"
fi
if [ -z $(docker images -q supermap/volumerize:1.5.0) ]; then
	docker pull $IMANAGER_REGISTRY_URL"supermap/volumerize:1.5.0"
	docker tag $IMANAGER_REGISTRY_URL"supermap/volumerize:1.5.0" supermap/volumerize:1.5.0
	docker rmi $IMANAGER_REGISTRY_URL"supermap/volumerize:1.5.0"
fi


if [[ `cat /etc/sysctl.conf  | grep -c vm.max_map_count` = 0 ]]; then
    echo "vm.max_map_count=262144" >> /etc/sysctl.conf
    sysctl -p
fi
/opt/compose/bin/docker-compose -f $Current_DIR/docker-compose.yml -p imanager up -d
